# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20250101


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class DistributedAutonomousDbMetadata(object):
    """
    Additional metadata related to Globally distributed autonomous database resources.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new DistributedAutonomousDbMetadata object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param map:
            The value to assign to the map property of this DistributedAutonomousDbMetadata.
        :type map: dict(str, str)

        """
        self.swagger_types = {
            'map': 'dict(str, str)'
        }
        self.attribute_map = {
            'map': 'map'
        }
        self._map = None

    @property
    def map(self):
        """
        Gets the map of this DistributedAutonomousDbMetadata.
        The map containing key-value pair of additional metadata.


        :return: The map of this DistributedAutonomousDbMetadata.
        :rtype: dict(str, str)
        """
        return self._map

    @map.setter
    def map(self, map):
        """
        Sets the map of this DistributedAutonomousDbMetadata.
        The map containing key-value pair of additional metadata.


        :param map: The map of this DistributedAutonomousDbMetadata.
        :type: dict(str, str)
        """
        self._map = map

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
