# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20200630

from .credential_details import CredentialDetails
from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class CredentialByNamedCredentials(CredentialDetails):
    """
    Credentials by named credentials stored in management agent to connect database
    """

    def __init__(self, **kwargs):
        """
        Initializes a new CredentialByNamedCredentials object with values from keyword arguments. The default value of the :py:attr:`~oci.opsi.models.CredentialByNamedCredentials.credential_type` attribute
        of this class is ``CREDENTIALS_BY_NAMED_CREDS`` and it should not be changed.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param credential_source_name:
            The value to assign to the credential_source_name property of this CredentialByNamedCredentials.
        :type credential_source_name: str

        :param credential_type:
            The value to assign to the credential_type property of this CredentialByNamedCredentials.
            Allowed values for this property are: "CREDENTIALS_BY_SOURCE", "CREDENTIALS_BY_VAULT", "CREDENTIALS_BY_IAM", "CREDENTIALS_BY_NAMED_CREDS"
        :type credential_type: str

        :param named_credential_id:
            The value to assign to the named_credential_id property of this CredentialByNamedCredentials.
        :type named_credential_id: str

        """
        self.swagger_types = {
            'credential_source_name': 'str',
            'credential_type': 'str',
            'named_credential_id': 'str'
        }
        self.attribute_map = {
            'credential_source_name': 'credentialSourceName',
            'credential_type': 'credentialType',
            'named_credential_id': 'namedCredentialId'
        }
        self._credential_source_name = None
        self._credential_type = None
        self._named_credential_id = None
        self._credential_type = 'CREDENTIALS_BY_NAMED_CREDS'

    @property
    def named_credential_id(self):
        """
        Gets the named_credential_id of this CredentialByNamedCredentials.
        The credential `OCID`__ stored in management agent.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The named_credential_id of this CredentialByNamedCredentials.
        :rtype: str
        """
        return self._named_credential_id

    @named_credential_id.setter
    def named_credential_id(self, named_credential_id):
        """
        Sets the named_credential_id of this CredentialByNamedCredentials.
        The credential `OCID`__ stored in management agent.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param named_credential_id: The named_credential_id of this CredentialByNamedCredentials.
        :type: str
        """
        self._named_credential_id = named_credential_id

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
