# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220315


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class CreateIdentityTokenDetails(object):
    """
    Generate an Identity token for Redis cluster
    """

    def __init__(self, **kwargs):
        """
        Initializes a new CreateIdentityTokenDetails object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param public_key:
            The value to assign to the public_key property of this CreateIdentityTokenDetails.
        :type public_key: str

        :param redis_user:
            The value to assign to the redis_user property of this CreateIdentityTokenDetails.
        :type redis_user: str

        :param freeform_tags:
            The value to assign to the freeform_tags property of this CreateIdentityTokenDetails.
        :type freeform_tags: dict(str, str)

        :param defined_tags:
            The value to assign to the defined_tags property of this CreateIdentityTokenDetails.
        :type defined_tags: dict(str, dict(str, object))

        """
        self.swagger_types = {
            'public_key': 'str',
            'redis_user': 'str',
            'freeform_tags': 'dict(str, str)',
            'defined_tags': 'dict(str, dict(str, object))'
        }
        self.attribute_map = {
            'public_key': 'publicKey',
            'redis_user': 'redisUser',
            'freeform_tags': 'freeformTags',
            'defined_tags': 'definedTags'
        }
        self._public_key = None
        self._redis_user = None
        self._freeform_tags = None
        self._defined_tags = None

    @property
    def public_key(self):
        """
        **[Required]** Gets the public_key of this CreateIdentityTokenDetails.
        User public key pair


        :return: The public_key of this CreateIdentityTokenDetails.
        :rtype: str
        """
        return self._public_key

    @public_key.setter
    def public_key(self, public_key):
        """
        Sets the public_key of this CreateIdentityTokenDetails.
        User public key pair


        :param public_key: The public_key of this CreateIdentityTokenDetails.
        :type: str
        """
        self._public_key = public_key

    @property
    def redis_user(self):
        """
        **[Required]** Gets the redis_user of this CreateIdentityTokenDetails.
        Redis User generating identity token.


        :return: The redis_user of this CreateIdentityTokenDetails.
        :rtype: str
        """
        return self._redis_user

    @redis_user.setter
    def redis_user(self, redis_user):
        """
        Sets the redis_user of this CreateIdentityTokenDetails.
        Redis User generating identity token.


        :param redis_user: The redis_user of this CreateIdentityTokenDetails.
        :type: str
        """
        self._redis_user = redis_user

    @property
    def freeform_tags(self):
        """
        Gets the freeform_tags of this CreateIdentityTokenDetails.
        Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
        Example: `{\"bar-key\": \"value\"}`


        :return: The freeform_tags of this CreateIdentityTokenDetails.
        :rtype: dict(str, str)
        """
        return self._freeform_tags

    @freeform_tags.setter
    def freeform_tags(self, freeform_tags):
        """
        Sets the freeform_tags of this CreateIdentityTokenDetails.
        Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
        Example: `{\"bar-key\": \"value\"}`


        :param freeform_tags: The freeform_tags of this CreateIdentityTokenDetails.
        :type: dict(str, str)
        """
        self._freeform_tags = freeform_tags

    @property
    def defined_tags(self):
        """
        Gets the defined_tags of this CreateIdentityTokenDetails.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`


        :return: The defined_tags of this CreateIdentityTokenDetails.
        :rtype: dict(str, dict(str, object))
        """
        return self._defined_tags

    @defined_tags.setter
    def defined_tags(self, defined_tags):
        """
        Sets the defined_tags of this CreateIdentityTokenDetails.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`


        :param defined_tags: The defined_tags of this CreateIdentityTokenDetails.
        :type: dict(str, dict(str, object))
        """
        self._defined_tags = defined_tags

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
